#ifndef VECTOR_H
#define VECTOR_H

typedef struct {
    float x;
    float y;
} vec2_t;

typedef struct {
    float x;
    float y;
    float z;
} vec3_t;

typedef struct {
    float x, y, z, w;
} vec4_t;

// TODO: Add functions to manipulate vectors 2D and 3D
// ...

vec3_t vec3_rotate_x(vec3_t v, float angle);
vec3_t vec3_rotate_y(vec3_t v, float angle);
vec3_t vec3_rotate_z(vec3_t v, float angle);

vec2_t vec2_add(const vec2_t a, const vec2_t b);
vec2_t vec2_subtract(const vec2_t a, const vec2_t b);
vec2_t vec2_multiply(const vec2_t vector, float scalar);
vec2_t vec2_divide(const vec2_t vector, float scalar);
float vec2_length(const vec2_t vector);
float vec2_dot(const vec2_t a, const vec2_t b);
void vec2_normalize(vec2_t* vertex);

vec3_t vec3_add(const vec3_t a, const vec3_t b);
vec3_t vec3_subtract(const vec3_t a, const vec3_t b);
vec3_t vec3_multiply(const vec3_t vector, const float scalar);
vec3_t vec3_divide(const vec3_t vector, const float scalar);
vec3_t vec3_cross(const vec3_t a, const vec3_t b);
float vec3_length(const vec3_t vector);
float vec3_dot(const vec3_t a, const vec3_t b);
void vec3_normalize(vec3_t* vertex);

vec4_t vec4_from_vec3(vec3_t vertex);
vec3_t vec3_from_vec4(vec4_t v);

#endif
